%**************************************************************************
%  Teora de Control
%   Ao 2017
%**************************************************************************

%**************************************************************************
%*                                                                        *
%*  CLCULOS PARA COMPARAR EL COMPORTMIENTO DE UN ESTIMADOR LUENBERGER    *
%*  CON EL ESTIMADOR DE KALMAN PARA MEDICIN CON RUIDO.                   *
%*  SE SIMULA EL COMPORTAMIENTO DEL ESTIMADOR CON RUIDO Y SE SELECCIONA   *
%*  LA UBICACIN DE LOS AUTOVALORES PARA MINIMIZAR EL RUIDO EN LA ESTIMA  *
%*  LUEGO SE COMPARA CON LA RESPUESTA DEL FILTRO DE KALMAN.               *
%*                                                                        *
%**************************************************************************

% Modelo de la laminadora

% ESTIMADOR DE ESTADOS
echo off
clear all
close all
% VALORES CORRESPONDIENTES AL EJERCICIO DE LA LAMINADORA
% MOTOR
Ra=2.4   
La=0.04
Kt=0.86
Kw=1.07
% CARGA MECANICA
B1=0.04
B2=2
J =0.025
K =500
% POLEAS
r1=0.1
r2=0.1
A0 =10
Kp=1
A=[-Ra/La -Kw/La 0; Kt/J -B1/J -K*r1/(2*J); 0 r1/2 -K/(4*B2)]
B=[A0/La; 0; 0]
C=[0 0 K/2]
D=0
clc
% Modelo de Estado Continuo
disp('Modelo de Estado Continuo de la Planta');
P1=ss(A,B,C,D)
Ts=0.01;
P2=c2d(P1,Ts);
str1=sprintf('\n Funcin de Transferencia Continua \n');
disp(str1);
g1=tf(P1);
g1
str1=sprintf('\n  \n');
disp(str1);
%pause
P1.c=[1 0 0; 0 1 0;C];
P1.d=[0;0;0];

%modelo de estado discreto

str1=sprintf('\n Modelo de Estado Discreto \n');
disp(str1);
P2
disp(' ');
G2=tf(P2)
[num,den]=tfdata(P2,'v');
Ac=[0,1,0;0,0,1;-den(4),-den(3),-den(2)];
Bc=[0;0;1];
Cc=[num(4),num(3),num(2)];
Dc=0;
%modelo canonico
clc;
str1=sprintf('\n Modelo Cannico Observable \n');
disp(str1);
P4=transpose(ss(Ac,Bc,Cc,Dc,0.01))
%pause
clc;
str1=sprintf('\n Matriz Observabilidad de la Planta Original \n');
disp(str1);
V1=obsv(P2)
str1=sprintf('\n Matriz Observabilidad del Modelo Canonico \n');
disp(str1);
V2=obsv(P4)
str1=sprintf('\n Matriz Transformacion al Modelo Canonico \n');
disp(str1);
Q=inv(V1)*V2
P5=ss2ss(P2,inv(Q));
%pause
clc;
close all;
disp('Autovalores del Estimador')

%z1=0;
%z2=0;
%z3=0;

z1=input('Ingrese el autovalor del estimador z1 = ');

z2=input('Ingrese el autovalor del estimador z2 = ');

z3=input('Ingrese el autovalor del estimador z3 = ');

str1=sprintf('\n Vector del Estimador del Modelo Canonico \n');
disp(str1);
H1=acker(Ac,Bc,[z1,z2,z3])'
str1=sprintf('\n Vector del Estimador transformado \n');
disp(str1);
H2=Q*H1

%pause
clc;

%Matrices del Estimador

Ae=(P2.a-H2*P2.c);
eig(Ae);
He=H2*P2.c;
Br=[0;0;0];
Be=[P2.b H2];
Ce=eye(3);
Xe0=[10,10,1];
De=zeros(3,2);



